#include <stdio.h>
#include <conio.h>
#include "document.h"
#include "rtfdoc.h"
#include "htmldoc.h"
#include "textdoc.h"
#include "foutstd.h"

int main()
{
	TDCDocument *doc;
#ifdef MULTIPLEFORMATS
	int ch;
	printf("Vlj typ (1 fr text, 2 fr HTML): ");
	do {
		ch = getch();
	} while ((ch != 49) && (ch != 50));
	if (ch == 1)
		doc = new TDCTextDocument("D:\\TEST.TXT", new TStdFileOutput());
	else
		doc = new TDCHtmlDocument("D:\\TEST.HTM", new TStdFileOutput());
#else
	doc = new TDCRtfDocument("D:\\TEST.RTF", new TStdFileOutput());
#endif
	doc->SetTitle("Test document for C++ project");
	doc->SetAuthor("Magnus Bck");
	doc->SetKeywords("test document C++ project");
	doc->Open();
//	doc->PutHeaders();
	doc->SetStyleSheet(SS_HEADING1);
	doc->PutText("Test document for C++ project");
	doc->SetStyleSheet(SS_NORMAL);
	doc->PutDivider();
//	*doc << "Testing operator overloading...";
	doc->PutText("This project is an example of how to be able to create ");
	doc->PutText("documents of many types and formats with the same source code ");
	doc->PutText("with the aid of ");
	doc->SetItalic(true);
	doc->PutText("far");
	doc->SetItalic(false);
	doc->PutText(" driven object-orientation and abstraction.");
	doc->SetStyleSheet(SS_FIRSTLINE);
	doc->PutText("The class library was designed with and for Borland C++ 4.0 ");
	doc->PutText("and above, but will with rather small modifications work ");
	doc->PutText("with other PC C++ compilers. However, porting it to Unix will ");
	doc->PutText("take a lot more work.");
	doc->SetStyleSheet(SS_NORMAL);
	doc->ParagraphBreak();
	doc->SetBold(true);
	doc->PutText("Features:");
	doc->SetBold(false);
	doc->ParagraphBreak();
	doc->BeginTable("A test table");
/*
	doc->AddCell(12);

	doc->AddCell(12);
	doc->PutText("Quarter 1");

	doc->AddCell(12);
	doc->PutText("Quarter 2");

	doc->AddCell(12);
	doc->PutText("Quarter 3");

	doc->AddCell(12);
	doc->PutText("Quarter 4");

	doc->AddCell(12);
	doc->PutText("Sum");

	doc->AddRow();

	doc->AddCell(12);
	doc->PutText("Region 1");

	doc->AddCell(12);
	doc->PutLong(33498);

	doc->AddCell(12);
	doc->PutLong(23499);

	doc->AddCell(12);
	doc->PutLong(43743);

	doc->AddCell(12);
	doc->PutLong(98574);

	doc->AddCell(12);
	doc->InsertFormula(CR_LEFT,CF_SUM,1);

	doc->AddRow();

	doc->AddCell(12);
	doc->PutText("Region 2");

	doc->AddCell(12);
	doc->PutLong(84373);

	doc->AddCell(12);
	doc->PutLong(34934);

	doc->AddCell(12);
	doc->PutLong(23732);

	doc->AddCell(12);
	doc->PutLong(87218);

	doc->AddCell(12);
	doc->InsertFormula(CR_LEFT,CF_SUM,1);

	doc->AddRow();

	doc->AddCell(12);
	doc->PutText("Region 3");

	doc->AddCell(12);
	doc->PutLong(87349);

	doc->AddCell(12);
	doc->PutLong(37784);

	doc->AddCell(12);
	doc->PutLong(34738);

	doc->AddCell(12);
	doc->PutLong(76684);

	doc->AddCell(12);
	doc->InsertFormula(CR_LEFT,CF_SUM,1);

	doc->AddRow();

	doc->AddCell(12);
	doc->PutText("Region 4");

	doc->AddCell(12);
	doc->PutLong(38747);

	doc->AddCell(12);
	doc->PutLong(11683);

	doc->AddCell(12);
	doc->PutLong(12354);

	doc->AddCell(12);
	doc->PutLong(26344);

	doc->AddCell(12);
	doc->InsertFormula(CR_LEFT,CF_SUM,1);

	doc->AddRow();

	doc->AddCell(12);
	doc->PutText("Region 5");

	doc->AddCell(12);
	doc->PutLong(37447);

	doc->AddCell(12);
	doc->PutLong(42373);

	doc->AddCell(12);
	doc->PutLong(45764);

	doc->AddCell(12);
	doc->PutLong(47648);

	doc->AddCell(12);
	doc->InsertFormula(CR_LEFT,CF_SUM,1);

	doc->AddRow();

	doc->AddCell(12);
	doc->PutText("Summary");

	doc->AddCell(12);
	doc->InsertFormula(CR_ABOVE,CF_SUM,1);

	doc->AddCell(12);
	doc->InsertFormula(CR_ABOVE,CF_SUM,1);

	doc->AddCell(12);
	doc->InsertFormula(CR_ABOVE,CF_SUM,1);

	doc->AddCell(12);
	doc->InsertFormula(CR_ABOVE,CF_SUM,1);*/
/*
	doc->AddCell(12);
	doc->InsertFormula(CR_ABOVE,CF_MEDIAN,1);
*/
//	doc->EndTable();

/*	doc->ParagraphBreak();
	doc->BeginBullets();
	doc->NewBullet();
	doc->PutText("Level 1 bullet");
	doc->NewBullet();
	doc->PutText("Level 1 bullet");
	doc->BeginBullets();
	doc->NewBullet();
	doc->PutText("Level 2 bullet");
	doc->NewBullet();
	doc->PutText("Level 2 bullet");
	doc->EndBullets();
	doc->NewBullet();
	doc->PutText("Level 1 bullet");
	doc->NewBullet();
	doc->PutText("Level 1 bullet");
	doc->EndBullets();*/
/*	doc->BeginBullets();
	doc->NewBullet();
	doc->PutText("Blaha blaha");
	doc->NewBullet();
	doc->PutText("Currently supported formats");
	doc->BeginNumbering();
	doc->NewNumber();
	doc->PutText("Text format (TXT)");
	doc->BeginNumbering();
	doc->NewNumber();
	doc->PutText("PC-ASCII support");
	doc->NewNumber();
	doc->PutText("Extendable to support any other character set by simply ");
	doc->PutText("deriving a new class for each character set. Only one method ");
	doc->PutText("needs to be overridden for it to work.");
	doc->EndNumbering();
	doc->NewNumber();
	doc->PutText("Hyper-Text Markup Language (HTM)");
	doc->NewNumber();
	doc->PutText("Rich Text Format (RTF)");
	doc->EndNumbering();
	doc->EndBullets();*/
//	doc->ParagraphBreak();
	doc->PutFooters();
	doc->Close();
	delete doc;
	return 0;
}
